/****************************************************************************
 * tx.cs.iconv
 * D module for <iconv.h> with a simple wrapper class
 ****************************************************************************/

module tx.cs.iconvh;

extern(C)
{
	typedef void* iconv_t;
	iconv_t iconv_open ( char*, char* );
	int     iconv_close( iconv_t );
	size_t  iconv( iconv_t, char**, size_t*, char**, size_t* );
}

class Iconv
{
	this( char* from, char* to )
	{
		cd = iconv_open( to, from );
	}

	~this()
	{
		iconv_close( cd );
	}

	string opCall( string from )
	{
		char[] to = new char[from.length*3];
		char*  ip = from.ptr;
		size_t iz = from.length;
		char*  op = to.ptr;
		size_t oz = to.length;

		iconv( cd, &ip, &iz, &op, &oz );
		iconv( cd, null, null, null, null ); // reset

		return to[0 .. op-to.ptr];
	}

	private const iconv_t cd;
}
