/****************************************************************************
 * tx.cs.native_iconv
 * Implemntation of tx.charset.NativeCharset using iconv
 * <<The CODESET constant should be modified to match your system>>
 ****************************************************************************/

module tx.cs.native_iconv;
import tx.cs.iconv;

private
{
	import std.c.locale;

	     version(linux)   const CODESET = 14;
	else version(freebsd) const CODESET = 0;
	else version(netbsd)  const CODESET = 51;
	else version(openbsd) const CODESET = 51;
	else version(Unix)    const CODESET = 49; // Solaris, AIX, Tru64, darwin(?)
	else const CODESET = 14;

	extern extern(C) char* nl_langinfo(int);

	static this()
	{
		setlocale(LC_CTYPE, "");
	}
}

class NativeCharset : tx.cs.iconv.Charset
{
	this() { super( nl_langinfo(CODESET) ); }

	static private NativeCharset theInstance;
	static NativeCharset opCall() { return theInstance; }
	static this() { theInstance = new NativeCharset; }
}
