/****************************************************************************
 * tx.to_s
 *   Module for anything-to-string conversion. One function template
 *      char[] to_s(T)(T v)
 *   is provided.
 ****************************************************************************/

module tx.to_s;
import std.string;

private template judge(T)
{
	int testAA(T,S)(T[S] v);
	const bool isAA = is(typeof(testAA(T.init)));
}

string to_s(T)( T v )
{
	static if( is(T == struct) )
	{
		static if( v.tupleof.length == 0 )
			return "{}";
		else
		{
			char[] buf, delim = "{";
			foreach( e; v.tupleof )
			{
				buf ~= delim;
				buf ~= to_s(e);
				delim = ", ";
			}
			return buf ~ "}";
		}
	}
	else
	static if( is(T == union) )
	{
		return "(union)";
	}
	else
	static if( is(T == function) )
	{
		return "(function)";
	}
	else
	static if( is(T == delegate) )
	{
		return "(function)";
	}
	else
	static if( is(T == class) )
	{
		return v ? v.toString() : "(null)";
	}
	else
	static if( is(T == interface) )
	{
		return v ? (cast(Object)v).toString() : "(null)";
	}
	else
	static if( is(T : char[]) )
	{
		return v.dup;
	}
	else
	static if( is(T : string) )
	{
		return v;
	}
	else
	static if( judge!(T).isAA )
	{
		if( v.length == 0 )
			return "[]";
		else
		{
			char[] buf, delim = "[";
			foreach( k,e; v )
			{
				buf ~= delim;
				buf ~= to_s(k);
				buf ~= "=>";
				buf ~= to_s(e);
				delim = ", ";
			}
			return buf ~ "]";
		}
	}
	else
	static if( is(typeof(T.sort)) )
	{
		if( v.length == 0 )
			return "[]";
		else
		{
			string buf, delim = "[";
			foreach( e; v )
			{
				buf ~= delim;
				buf ~= to_s(e);
				delim = ", ";
			}
			return buf ~ "]";
		}
	}
	else
	{
		return std.string.toString(v);
	}
}
